--- apt-show-versions.orig	2012-10-26 21:04:26.000000000 +0200
+++ apt-show-versions	2013-01-24 21:05:37.079635767 +0100
@@ -69,6 +69,7 @@
 my $SUITE    = 'Suite';
 my $UNKNOWN  = 'unknown';
 my $VERS     = 'Version';
+my $ARCH     = 'Architecture';
 
 # process commandline parameters
 my %opts;
@@ -518,6 +519,7 @@
         if (/^$/){
             unless (defined $package) {next};
 
+            my $package_arch = $package->{$PACKAGE} . ':' . $package->{$ARCH};
             if ($status) { # Are we parsing the status file?
                 # if we did not specify a package or pattern
                 # only include installed packages
@@ -525,21 +527,21 @@
                         ($package->{$STATUS} =~ /not-installed|config-files/ or
                          # don't print holded packages if requested
                          ($opts{'nohold'} and $package->{$STATUS} =~ /hold/))) {
-                    $packages->{ $package->{$PACKAGE}} = $package;
+                    $packages->{$package_arch} = $package;
                 }
             }
             else {
-                if (!defined $packages->{$package->{$PACKAGE}} or
-                    $vs->compare($packages->{$package->{$PACKAGE}}{$VERS},
+                if (!defined $packages->{$package_arch} or
+                    $vs->compare($packages->{$package_arch}{$VERS},
                         $package->{$VERS}) < 0) {
                     $package->{$RELEASE} = $release;
-                    $packages->{$package->{$PACKAGE}} = $package;
+                    $packages->{$package_arch} = $package;
                 }
             }
             undef $package;
             next;
         }
-        unless ((/^Package/) || (/^Version/) || (/^Status/) || (/^Source/)) {next};
+        unless ((/^Package/) || (/^Version/) || (/^Status/) || (/^Source/) || (/^Architecture/)) {next};
         ($key, $value) = split /: /, $_;
         $value =~ s/\n//;
         $value =~ s/\s\(.*\)$//; # Remove any Version information in ()
